      Subroutine Jacobian (Jac,Det,NDim,NodG,XL,dF)
      Implicit real*8 (a-h,o-z)
      Dimension dF(NDim,NodG),XL(*)
!      ojo que en algun lugar dF(NDimE,NodEL)
! Hay que hacer compatible esta cuestion de diemensionamientos

      Real*8 JacInv(NDim,NDim)
      Real*8 Jac(NDim,NDim)

!      Do iGC=1,NDim
!      Do iLC=1,NDim
!          JacInv(iGC,iLC)= 0.0d0
!      Enddo
!      Enddo
      JacInv = 0.0d0

      Do Nod=1,NodG
      iPNod = (Nod-1)*NDim
      Do iGC=1,NDim
      Do iLC=1,NDim
         JacInv(iLC,iGC) = JacInv(iLC,iGC) +  &
                           XL( iPNod + iGC ) * dF(iLC,Nod) 	
      Enddo
      Enddo
      Enddo
! Ya no (Uso de rutina IMSL para invertir JacInv y obtener Jac)

      Select Case (NDim)
      Case (1)
      	Determinant = JacInv(1,1)
      if (Determinant .NE.0.0d0 ) then
      	Jac(1,1)    = 1.0d0 / Determinant
      else
          Write (*,*)'WARNING, Element Jacobian = 0'
          Write (*,*)'WARNING, Element Jacobian = 0'
          Write (*,*)'WARNING, Element Jacobian = 0'
          Stop
	endif

      Case (2)
          Determinant = JacInv(1,1)*JacInv(2,2)-JacInv(1,2)*JacInv(2,1)
          if (Determinant .NE.0.0d0 ) then
      	    Jac(1,1)    = JacInv(2,2) / Determinant
      	    Jac(1,2)    =-JacInv(1,2) / Determinant
      	    Jac(2,1)    =-JacInv(2,1) / Determinant
      	    Jac(2,2)    = JacInv(1,1) / Determinant
          else
            Write (*,*)'WARNING, Element Jacobian = 0'
            Write (*,*)'WARNING, Element Jacobian = 0'
            Write (*,*)'WARNING, Element Jacobian = 0'
            Stop
          endif


       Case (3)
	      A1 = JacInv(3,3)*JacInv(2,2) - JacInv(3,2)*JacInv(2,3)
          B1 = JacInv(3,3)*JacInv(2,1) - JacInv(3,1)*JacInv(2,3)
          C1 = JacInv(3,2)*JacInv(2,1) - JacInv(3,1)*JacInv(2,2)

	      A2 = JacInv(3,3)*JacInv(1,2) - JacInv(3,2)*JacInv(1,3)
          B2 = JacInv(3,3)*JacInv(1,1) - JacInv(3,1)*JacInv(1,3)
          C2 = JacInv(3,2)*JacInv(1,1) - JacInv(3,1)*JacInv(1,2)

	      A3 = JacInv(2,3)*JacInv(1,2) - JacInv(2,2)*JacInv(1,3)
          B3 = JacInv(2,3)*JacInv(1,1) - JacInv(2,1)*JacInv(1,3)
          C3 = JacInv(2,2)*JacInv(1,1) - JacInv(2,1)*JacInv(1,2)

          Determinant= JacInv(1,1)*A1 - JacInv(1,2)*B1 + JacInv(1,3)*C1 

         if (Determinant .NE.0.0d0 ) then
      	  Jac(1,1)    = A1 / Determinant
      	  Jac(1,2)    =-A2 / Determinant
      	  Jac(1,3)    = A3 / Determinant

      	  Jac(2,1)    =-B1 / Determinant
      	  Jac(2,2)    = B2 / Determinant
      	  Jac(2,3)    =-B3 / Determinant

      	  Jac(3,1)    = C1 / Determinant
      	  Jac(3,2)    =-C2 / Determinant
      	  Jac(3,3)    = C3 / Determinant
         else
          Write (*,*)'WARNING, Element Jacobian = 0'
          Write (*,*)'WARNING, Element Jacobian = 0'
          Write (*,*)'WARNING, Element Jacobian = 0'
          Stop
        endif

      Case default
        Write (*,*)'Invalid Case for Determinant of element"s Jacobian'
        Write (*,*)'Dimension of Simplex not contained in 1-3',NDim
        Write (*,*)'WARNING, Jacobian of an element = 0'
        Stop
!           Determinant=0.0d0
      
      End Select

!      Det = Determinant(NDim,JacInv)
      Det = Determinant

      if (Det < 0.0d0) then
          Write (*,*)'!!!!! WARNING, Jacobian of an element < 0'
      End if

!      CALL DLINRG (NDim, JacInv, NDim, Jac, NDim)

      Return
      End
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Real*8 function Determinant(NDim,Jac)
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Implicit real*8 (a-h,o-z)
      Real*8 Jac(NDim,NDim)

      Select Case (NDim)
      Case (1)
      	Determinant = Jac(1,1)
      Case (2)
          Determinant = Jac(1,1)*Jac(2,2)-Jac(1,2)*Jac(2,1)
      Case (3)
      Determinant = Jac(1,1)*(Jac(3,3)*Jac(2,2)-Jac(3,2)*Jac(2,3))      &
     &            - Jac(1,2)*(Jac(3,3)*Jac(2,1)-Jac(3,1)*Jac(2,3))      &
     &            + Jac(1,3)*(Jac(3,2)*Jac(2,1)-Jac(3,1)*Jac(2,2))    
      Case default
!        Write (*,*)'Invalid Case for Determinant of element"s Jacobian'
!        Write (*,*)'Dimension of Simplex not contained in 1-3',NDim
        Determinant=0.0d0
      
      End Select

      Return
      End
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine LocalShapeDer (NodEL,NDim,dF,GaussPoint,Iorder,iBu)
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Implicit real*8 (a-h,o-z)
      Dimension dF(NDim,NodEL),GaussPoint(NDim)
      Integer d(NDim)
! Ejemplo: ndim=3, d(3) vector indicador de la derivada de primer orden = d/dy-> [0,1,0]
!    iBu = 1 Bubble element, iBu=0 Linear_Element
!    NLSF=NDim+1+iBu : Number of Linear Shape Functions
      Deriv=1
      NLSF=NDim+1+iBu
      d=0

      Do Nod=1,NodEL
          Do iLC=1,NDim

           d(iLC)=1
           if (Iorder .eq. 1 .and. Nod .GT. NLSF) then
             dF(iLC,Nod)= 0.0d0
           else
             dF(iLC,Nod)= SFSimplex(GaussPoint,d,Iorder,Nod,NDim)	
           endif
           d(iLC)=0

          Enddo
      Enddo

      Return
      End
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine GlobalShapeDer (NodEL,NDim,dF_L,dF_G,Jac)
      Implicit real*8 (a-h,o-z)
      Dimension dF_L(NDim,NodEL),dF_G(NDim,NodEL)
      Real*8 Jac(NDim,NDim)

!      Do Nod=1,NodEL
!          Do iGC=1,NDim
!      		      dF_G(iGC,Nod)=0.0d0 	
!          Enddo
!	Enddo
      dF_G = 0.0d0 	

      Do Nod=1,NodEL
       Do iLC=1,NDim
        Do iGC=1,NDim
      	 dF_G(iGC,Nod)= dF_G (iGC,Nod)+ dF_L(iLC,Nod)*Jac(iGC,iLC) 	
        Enddo
       Enddo
      Enddo

      Return
      End

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine ShapeF (NodEL,NDim,F,GaussPoint,iOrder,iBu)
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Implicit real*8 (a-h,o-z)
      Dimension F(NodEL),GaussPoint(NDim)
!    iBu = 1 Bubble element, iBu=0 Linear_Element
!    NLSF=NDim+1+iBu : Number of Linear Shape Functions
!    iOrder = Interpolation order: 1=Linear; 2=Cuadratic
      Integer d(NDim)

      d=0
      NLSF=NDim+1+iBu

      Do Nod=1,NodEL
        if (Iorder .eq. 1 .and. Nod .GT. NLSF) then
         F(Nod)= 0.0d0
        else
         F(Nod)= SFSimplex(GaussPoint,d,iOrder,Nod,NDim)	
        endif
      Enddo
   
      Return
      End
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
      Subroutine GaussRule (Psi,W,NDim,NGP,iSimplex)    
      Implicit real*8 (a-h,o-z)
      Dimension PSI(NDim,NGP),W(NGP)
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      

      CaseSimplex: Select case (iSimplex)
!     iSimplex = 0 -> The element is a Simplex 
!     iSimplex = 1 -> The element is a HiperCube 


      Case (0)
!     The element is a simplex

        CaseNDimSimplex: Select case (NDim)

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!     gauss points for  tetrahedral elements
!     last modifief 19/9/01
 
  	  Case (3)

	    CaseNGP3d: Select case (NGP)

	    Case (1)
         !     tetrahedral 1-points formula, degree of precision 1
         !     Gauss Points Intrinsic Coordinates
            PSI(1,1) = 0.25D0
	        PSI(2,1) = 0.25D0
	        PSI(3,1) = 0.25D0
            !  Weights/6
            W(1) = 1.0D0*0.166666666666667D0

	    Case (4)
        !     tetrahedral 4-points formula, degree of precision 2
        !     Gauss Points Intrinsic Coordinates

            PSI(1,1) = 0.13819660D0
            PSI(2,1) = 0.13819660D0
            PSI(3,1) = 0.13819660D0
            PSI(1,2) = 0.58541020D0
            PSI(2,2) = 0.13819660D0
            PSI(3,2) = 0.13819660D0
            PSI(1,3) = 0.13819660D0
            PSI(2,3) = 0.58541020D0
            PSI(3,3) = 0.13819660D0
            PSI(1,4) = 0.13819660D0
            PSI(2,4) = 0.13819660D0
            PSI(3,4) = 0.58541020D0
             !     Weights/6
                WT   = 0.25D0*0.1666666666666667D0
                W(1) = WT
	            W(2) = WT
                W(3) = WT
                W(4) = WT

		  Case (5)
          !     tetrahedral 5-points formula, degree of precision 3
          !     Gauss Points Intrinsic Coordinates
            PSI(1,1) = 0.25D0
            PSI(2,1) = 0.25D0
            PSI(3,1) = 0.25D0
            PSI(1,2) = 0.1666666666666667D0
            PSI(2,2) = 0.1666666666666667D0
            PSI(3,2) = 0.1666666666666667D0
            PSI(1,3) = 0.3333333333333333D0
            PSI(2,3) = 0.1666666666666667D0
            PSI(3,3) = 0.1666666666666667D0
            PSI(1,4) = 0.1666666666666667D0
            PSI(2,4) = 0.3333333333333333D0
            PSI(3,4) = 0.1666666666666667D0
            PSI(1,5) = 0.1666666666666667D0
            PSI(2,5) = 0.1666666666666667D0
            PSI(3,5) = 0.3333333333333333D0

             !     Weights/6
                W(1) = - 0.80D0*0.1666666666666667D0
                WT   =   0.45D0*0.1666666666666667D0
                W(2) = WT
                W(3) = WT
                W(4) = WT
                W(5) = WT

		  Case (11)
          !     Tetrahedral 11-points formula, degree of precision 4
          !     Gauss Points Intrinsic Coordinates
          ! See reference: Yen Liu and Marcel Vinokur, "Exact Integrations of Polynomials and
          !       Symmetric Quadrature Formulas over Arbitrary Polyhedral Grids",
          !       NASA Report > NASA TM-112202; Ames Research Center A-976805 

            PSI(1,1) = 0.25D0
            PSI(2,1) = 0.25D0
            PSI(3,1) = 0.25D0

            ! Vertex based points
            Alpha = 5.0d0/7.0d0
            Psi1  = 0.25d0 + 0.75d0 * Alpha
            Psi2  = 0.25d0 * ( 1.0d0 - Alpha )
            PSI(1,2) = Psi2
            PSI(2,2) = Psi2
            PSI(3,2) = Psi2

            PSI(1,3) = Psi1
            PSI(2,3) = Psi2
            PSI(3,3) = Psi2

            PSI(1,4) = Psi2
            PSI(2,4) = Psi1
            PSI(3,4) = Psi2

            PSI(1,5) = Psi2
            PSI(2,5) = Psi2
            PSI(3,5) = Psi1

            ! Side based points
            Beta  = Dsqrt( 70.0d0 ) / 28.0d0
            Psi1  = 0.25d0 + 0.5d0 * Beta
            Psi2  = 0.25d0 - 0.5d0 * Beta
            PSI(1,6) = Psi1
            PSI(2,6) = Psi1
            PSI(3,6) = Psi2

            PSI(1,7) = Psi1
            PSI(2,7) = Psi2
            PSI(3,7) = Psi1

            PSI(1,8) = Psi2
            PSI(2,8) = Psi1
            PSI(3,8) = Psi1

            PSI(1,9) = Psi2
            PSI(2,9) = Psi2
            PSI(3,9) = Psi1

            PSI(1,10)= Psi2
            PSI(2,10)= Psi1
            PSI(3,10)= Psi2

            PSI(1,11)= Psi1
            PSI(2,11)= Psi2
            PSI(3,11)= Psi2

             !     Weights/6
                W(1) = - ( 1.48D2 / 1.875D3 ) * 0.1666666666666667D0
                WT   =   ( 3.43D2 / 7.5D3   ) * 0.1666666666666667D0
                W(2) = WT
                W(3) = WT
                W(4) = WT
                W(5) = WT

                WTB   =   ( 5.6D1 / 3.75D2   ) * 0.1666666666666667D0
                W(6 ) = WTB
                W(7 ) = WTB
                W(8 ) = WTB
                W(9 ) = WTB
                W(10) = WTB
                W(11) = WTB

       EndSelect CaseNGP3d
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!     gauss points for triangular elements
        Case (2)

          CaseNGP2d: Select case (NGP)

          Case (1)
!     triangle 1-points formula, degree of precision 1
!     Gauss Points Intrinsic Coordinates 
              PSI(1,1) = 0.333333333333333D0
              PSI(2,1) = 0.333333333333333D0
!            Weights/2  
              W(1) = 1.0D0 *0.5d0

          Case (3)
!     triangle 3-points formula, degree of precision 2
!     Gauss Points Intrinsic Coordinates
              PSI(1,1) = 0.166666666666667D0
              PSI(2,1) = 0.166666666666667D0
              PSI(1,2) = 0.666666666666667D0
              PSI(2,2) = 0.166666666666667D0
              PSI(1,3) = 0.166666666666667D0
              PSI(2,3) = 0.666666666666667D0
!            Weights/2  
              WT   = 0.333333333333333D0 *0.5d0
              W(1) = WT
              W(2) = WT
              W(3) = WT

          Case (4)
!     triangle 4-points formula, degree of precision 3
!     Gauss Points Intrinsic Coordinates 
              PSI(1,1) = 0.2D0
              PSI(2,1) = 0.2D0
              PSI(1,2) = 0.6D0
              PSI(2,2) = 0.2D0
              PSI(1,3) = 0.2D0
              PSI(2,3) = 0.6D0
              PSI(1,4) = 0.333333333333333D0
              PSI(2,4) = 0.333333333333333D0
!            Weights/2  
              WT   = 0.520833333333333D0 *0.5d0
              W(1) = WT
              W(2) = WT
              W(3) = WT
              W(4) = - 0.56250D0 *0.5d0

          Case (6)
!     triangle 6-points formula, degree of precision 4
!     Gauss Points Intrinsic Coordinates 
              PSI(1,1) = 0.091576213509771D0
              PSI(2,1) = 0.091576213509771D0
              PSI(1,2) = 0.445948490915965D0
              PSI(2,2) = 0.445948490915965D0
              PSI(1,3) = 0.816847572980459D0
              PSI(2,3) = 0.091576213509771D0
              PSI(1,4) = 0.108103018168070D0
              PSI(2,4) = 0.445948490915965D0
              PSI(1,5) = 0.091576213509771D0
              PSI(2,5) = 0.816847572980459D0
              PSI(1,6) = 0.445948490915965D0
              PSI(2,6) = 0.108103018168070D0
!            Weights/2  
              WT1  = 0.109951743655322D0 *0.5d0
              WT2  = 0.223381589678011D0 *0.5d0
              W(1) = WT1
              W(2) = WT2
              W(3) = WT1
              W(4) = WT2
              W(5) = WT1
              W(6) = WT2

           Case (7)
!     triangle 7-points formula, degree of precision 5
!     Gauss Points Intrinsic Coordinates 
              PSI(1,1) = 0.333333333333333D0
              PSI(2,1) = 0.333333333333333D0
              PSI(1,2) = 0.101286507323456D0
              PSI(2,2) = 0.101286507323456D0
              PSI(1,3) = 0.470142064105115D0
              PSI(2,3) = 0.470142064105115D0
              PSI(1,4) = 0.797426985353087D0
              PSI(2,4) = 0.101286507323456D0
              PSI(1,5) = 0.059715871789770D0
              PSI(2,5) = 0.470142064105115D0
              PSI(1,6) = 0.101286507323456D0
              PSI(2,6) = 0.797426985353087D0
              PSI(1,7) = 0.470142064105115D0
              PSI(2,7) = 0.059715871789770D0
!            Weights/2  
              W(1) = 0.225000000000000d0 *0.5d0
              WT1  = 0.125939180544827d0 *0.5d0
              WT2  = 0.132394152788506d0 *0.5d0
              W(2) = WT1
              W(3) = WT2
              W(4) = WT1
              W(5) = WT2
              W(6) = WT1
              W(7) = WT2


           Case (13)
!     triangle 13-points formula, degree of precision 7 http://people.scs.fsu.edu/~burkardt/datasets/quadrature_rules_tri/quadrature_rules_tri.html
!     Gauss Points Intrinsic Coordinates 
!     Gilbert Strang, George Fix,
!     An Analysis of the Finite Element Method,
!     Cambridge, 1973,
!     ISBN: 096140888X,
!     LC: TA335.S77. 

              PSI1=0.479308067841923D0
              PSI2=0.260345966079038D0
              PSI3=0.869739794195568D0
              PSI4=0.065130102902216D0
              PSI5=0.638444188569809D0
              PSI6=0.312865496004875D0
              PSI7=0.048690315425316D0
                
              PSI(1,1) = 0.333333333333333D0
              PSI(2,1) = 0.333333333333333D0

              PSI(1,2) = PSI1
              PSI(2,2) = PSI2
              PSI(1,3) = PSI2
              PSI(2,3) = PSI1
              PSI(1,4) = PSI2
              PSI(2,4) = PSI2

              PSI(1,5) = PSI3
              PSI(2,5) = PSI4
              PSI(1,6) = PSI4
              PSI(2,6) = PSI3
              PSI(1,7) = PSI4
              PSI(2,7) = PSI4

              PSI(1,8) = PSI5
              PSI(2,8) = PSI6
              PSI(1,9) = PSI5
              PSI(2,9) = PSI7
              PSI(1,10)= PSI6
              PSI(2,10)= PSI5
              PSI(1,11)= PSI6
              PSI(2,11)= PSI7
              PSI(1,12)= PSI7
              PSI(2,12)= PSI5
              PSI(1,13)= PSI7
              PSI(2,13)= PSI6

!            Weights/2  
              W(1) =-0.149570044467670d0 *0.5d0
              WT1  = 0.175615257433204d0 *0.5d0
              WT2  = 0.053347235608839d0 *0.5d0
              WT3  = 0.077113760890257d0 *0.5d0

              W(2) = WT1
              W(3) = WT1
              W(4) = WT1
              W(5) = WT2
              W(6) = WT2
              W(7) = WT2
              W(8) = WT3
              W(9) = WT3
              W(10)= WT3
              W(11)= WT3
              W(12)= WT3
              W(13)= WT3
 

           EndSelect CaseNGP2d
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!         Gauss Points for 1D segments as simplexs(gauss coordinates between[0-1] )

        Case (1)
!       NDim=1
!       integrates exactly a polynomial of order 2*NGP-1
          CaseNGP1D: Select case (NGP)
              Case (1)
                  PSI(1,1) = 0.5D0
                  W(1) = 1.0d0

              Case (2)
                  GaussPoint1 = 1.0d0/Dsqrt(3.0d0)      
                  PSI(1,1) = 0.5d0*( 1.0d0 - GaussPoint1 )
                  PSI(1,2) = 0.5d0*( 1.0d0 + GaussPoint1 )
                  W(1) = 0.5d0
                  W(2) = 0.5d0

              Case (3)
                  GaussPoint1 = Dsqrt(0.6d0)      
                  PSI(1,1) = 0.5d0*( 1.0d0 - GaussPoint1 )
                  PSI(1,2) = 0.5d0*( 1.0d0 + GaussPoint1 )
                  PSI(1,3) = 0.5d0
                  W1 = 2.5d0/9.0d0 
                  W(1) = W1
                  W(2) = W1
                  W(3) = 4.0d0/9.0d0

              Case (4)
                  R = Dsqrt(1.2d0)
                  GaussPoint1 = Dsqrt( (3.0d0+2.0d0*R) / 7.0d0 )      
                  GaussPoint2 = Dsqrt( (3.0d0-2.0d0*R) / 7.0d0 )      
                  PSI(1,1) = 0.5d0*( 1.0d0 - GaussPoint1 )
                  PSI(1,2) = 0.5d0*( 1.0d0 + GaussPoint1 )
                  PSI(1,3) = 0.5d0*( 1.0d0 - GaussPoint2 )
                  PSI(1,4) = 0.5d0*( 1.0d0 + GaussPoint2 )
                  W1 = 1.0d0 / (12.0d0*R)
                  W(1) = (0.25d0-W1)
                  W(2) = (0.25d0-W1)
                  W(3) = (0.25d0+W1)
                  W(4) = (0.25d0+W1)
!!!!Revisar estas reglas que agreg pablo
              Case (5)
				  Csi1 = -0.9061798459386639
				  Csi2 = -0.5384693101056830
				  Csi3 =  0.0d0
				  Csi4 = -Csi2
				  Csi5 = -Csi1

				  PSI(1,1) = 0.5d0 * ( Csi1 + 1.0d0 )
				  PSI(1,2) = 0.5d0 * ( Csi2 + 1.0d0 )
				  PSI(1,3) = 0.5d0 * ( Csi3 + 1.0d0 )
				  PSI(1,4) = 0.5d0 * ( Csi4 + 1.0d0 )
				  PSI(1,5) = 0.5d0 * ( Csi5 + 1.0d0 )

				  W(1) = 0.5d0 * 0.2369268850561890
				  W(2) = 0.5d0 * 0.4786286704993664
				  W(3) = 0.5d0 * 0.5688888888888888
				  W(4) = W(2)
				  W(5) = W(1)

              Case (6)
				  Csi1 = -0.9324695142031520
				  Csi2 = -0.6612093864662645
				  Csi3 = -0.2386191860831969
				  Csi4 = -Csi3
				  Csi5 = -Csi2
				  Csi6 = -Csi1

				  PSI(1,1) = 0.5d0 * ( Csi1 + 1.0d0 )
				  PSI(1,2) = 0.5d0 * ( Csi2 + 1.0d0 )
				  PSI(1,3) = 0.5d0 * ( Csi3 + 1.0d0 )
				  PSI(1,4) = 0.5d0 * ( Csi4 + 1.0d0 )
				  PSI(1,5) = 0.5d0 * ( Csi5 + 1.0d0 )
				  PSI(1,6) = 0.5d0 * ( Csi6 + 1.0d0 )

				  W(1) = 0.5d0 * 0.1713244923791703
				  W(2) = 0.5d0 * 0.3607615730481386
				  W(3) = 0.5d0 * 0.4679139345726910
				  W(4) = W(3)
				  W(5) = W(2)
				  W(6) = W(1)

              Case (7)
				  Csi1 = -0.9491079123427585
				  Csi2 = -0.7415311855993944
				  Csi3 = -0.4058451513773971
				  Csi4 = 0.0d0
				  Csi5 = -Csi3
				  Csi6 = -Csi2
				  Csi7 = -Csi1

				  PSI(1,1) = 0.5d0 * ( Csi1 + 1.0d0 )
				  PSI(1,2) = 0.5d0 * ( Csi2 + 1.0d0 )
				  PSI(1,3) = 0.5d0 * ( Csi3 + 1.0d0 )
				  PSI(1,4) = 0.5d0 * ( Csi4 + 1.0d0 )
				  PSI(1,5) = 0.5d0 * ( Csi5 + 1.0d0 )
				  PSI(1,6) = 0.5d0 * ( Csi6 + 1.0d0 )
				  PSI(1,7) = 0.5d0 * ( Csi7 + 1.0d0 )

				  W(1) = 0.5d0 * 0.1294849661688696
				  W(2) = 0.5d0 * 0.2797053914892766
				  W(3) = 0.5d0 * 0.3818300505051189
				  W(4) = 0.5d0 * 0.4179591836734693
				  W(5) = W(3)
				  W(6) = W(2)
				  W(7) = W(1)

              Case (8)
				  Csi1 = -0.9602898564975362
				  Csi2 = -0.7966664774136267
				  Csi3 = -0.5255324099163289
				  Csi4 = -0.1834346424956498
				  Csi5 = -Csi4
				  Csi6 = -Csi3
				  Csi7 = -Csi2
				  Csi8 = -Csi1

				  PSI(1,1) = 0.5d0 * ( Csi1 + 1.0d0 )
				  PSI(1,2) = 0.5d0 * ( Csi2 + 1.0d0 )
				  PSI(1,3) = 0.5d0 * ( Csi3 + 1.0d0 )
				  PSI(1,4) = 0.5d0 * ( Csi4 + 1.0d0 )
				  PSI(1,5) = 0.5d0 * ( Csi5 + 1.0d0 )
				  PSI(1,6) = 0.5d0 * ( Csi6 + 1.0d0 )
				  PSI(1,7) = 0.5d0 * ( Csi7 + 1.0d0 )
				  PSI(1,8) = 0.5d0 * ( Csi8 + 1.0d0 )

				  W(1) = 0.5d0 * 0.1012285362903762
				  W(2) = 0.5d0 * 0.2223810344533744
				  W(3) = 0.5d0 * 0.3137066458778872
				  W(4) = 0.5d0 * 0.3626837833783619
				  W(5) = W(4)
				  W(6) = W(3)
				  W(7) = W(2)
				  W(8) = W(1)

              Case (9)
				  Csi1 = -0.9681602395076260
				  Csi2 = -0.8360311073266357
				  Csi3 = -0.6133714327005903
				  Csi4 = -0.3242534234038089
				  Csi5 = 0.0d0
				  Csi6 = -Csi4
				  Csi7 = -Csi3
				  Csi8 = -Csi2
				  Csi9 = -Csi1

				  PSI(1,1) = 0.5d0 * ( Csi1 + 1.0d0 )
				  PSI(1,2) = 0.5d0 * ( Csi2 + 1.0d0 )
				  PSI(1,3) = 0.5d0 * ( Csi3 + 1.0d0 )
				  PSI(1,4) = 0.5d0 * ( Csi4 + 1.0d0 )
				  PSI(1,5) = 0.5d0 * ( Csi5 + 1.0d0 )
				  PSI(1,6) = 0.5d0 * ( Csi6 + 1.0d0 )
				  PSI(1,7) = 0.5d0 * ( Csi7 + 1.0d0 )
				  PSI(1,8) = 0.5d0 * ( Csi8 + 1.0d0 )
				  PSI(1,9) = 0.5d0 * ( Csi9 + 1.0d0 )

				  W(1) = 0.5d0 * 0.0812743883615744
				  W(2) = 0.5d0 * 0.1806481606948574
				  W(3) = 0.5d0 * 0.2606106964029354
				  W(4) = 0.5d0 * 0.3123470770400028
				  W(5) = 0.5d0 * 0.3302393550012597
				  W(6) = W(4)
				  W(7) = W(3)
				  W(8) = W(2)
				  W(9) = W(1)

              Case (10)
				  Csi1  = -0.9739065285171717630000000
				  Csi2  = -0.8650633666889845550000000
				  Csi3  = -0.6794095682990243870000000
				  Csi4  = -0.4333953941292472020000000
				  Csi5  = -0.1488743389816312150000000
				  Csi6  = -Csi5
				  Csi7  = -Csi4
				  Csi8  = -Csi3
				  Csi9  = -Csi2
				  Csi10 = -Csi1

				  PSI(1,1)  = 0.5d0 * ( Csi1  + 1.0d0 )
				  PSI(1,2)  = 0.5d0 * ( Csi2  + 1.0d0 )
				  PSI(1,3)  = 0.5d0 * ( Csi3  + 1.0d0 )
				  PSI(1,4)  = 0.5d0 * ( Csi4  + 1.0d0 )
				  PSI(1,5)  = 0.5d0 * ( Csi5  + 1.0d0 )
				  PSI(1,6)  = 0.5d0 * ( Csi6  + 1.0d0 )
				  PSI(1,7)  = 0.5d0 * ( Csi7  + 1.0d0 )
				  PSI(1,8)  = 0.5d0 * ( Csi8  + 1.0d0 )
				  PSI(1,9)  = 0.5d0 * ( Csi9  + 1.0d0 )
				  PSI(1,10) = 0.5d0 * ( Csi10 + 1.0d0 )

				  W(1)  = 0.5d0 * 0.0666713443086881300000000
				  W(2)  = 0.5d0 * 0.1494513491505805840000000
				  W(3)  = 0.5d0 * 0.2190863625159820020000000
				  W(4)  = 0.5d0 * 0.2692667193099963450000000
				  W(5)  = 0.5d0 * 0.2955242247147528700000000
				  W(6)  = W(5)
				  W(7)  = W(4)
				  W(8)  = W(3)
				  W(9)  = W(2)
				  W(10) = W(1)

              Case (11)
				  Csi1  = -0.9782286581460569750000000
				  Csi2  = -0.8870625997680952710000000
				  Csi3  = -0.7301520055740492760000000
				  Csi4  = -0.5190961292068117690000000
				  Csi5  = -0.2695431559523449880000000
				  Csi6  = 0.0d0
				  Csi7  = -Csi5
				  Csi8  = -Csi4
				  Csi9  = -Csi3
				  Csi10 = -Csi2
				  Csi11 = -Csi1

				  PSI(1,1)  = 0.5d0 * ( Csi1  + 1.0d0 )
				  PSI(1,2)  = 0.5d0 * ( Csi2  + 1.0d0 )
				  PSI(1,3)  = 0.5d0 * ( Csi3  + 1.0d0 )
				  PSI(1,4)  = 0.5d0 * ( Csi4  + 1.0d0 )
				  PSI(1,5)  = 0.5d0 * ( Csi5  + 1.0d0 )
				  PSI(1,6)  = 0.5d0 * ( Csi6  + 1.0d0 )
				  PSI(1,7)  = 0.5d0 * ( Csi7  + 1.0d0 )
				  PSI(1,8)  = 0.5d0 * ( Csi8  + 1.0d0 )
				  PSI(1,9)  = 0.5d0 * ( Csi9  + 1.0d0 )
				  PSI(1,10) = 0.5d0 * ( Csi10 + 1.0d0 )
				  PSI(1,11) = 0.5d0 * ( Csi11 + 1.0d0 )

				  W(1)  = 0.5d0 * 0.0556685671161737241000000
				  W(2)  = 0.5d0 * 0.1255803694649045830000000
				  W(3)  = 0.5d0 * 0.1862902109277343250000000
				  W(4)  = 0.5d0 * 0.2331937645919904670000000
				  W(5)  = 0.5d0 * 0.2628045445102466520000000
				  W(6)  = 0.5d0 * 0.2729250867779006310000000
				  W(7)  = W(5)
				  W(8)  = W(4)
				  W(9)  = W(3)
				  W(10) = W(2)
				  W(11) = W(1)

              Case (12)
				  Csi1  = -0.9815606342467192120000000
				  Csi2  = -0.9041172563704748800000000
				  Csi3  = -0.7699026741943046590000000
				  Csi4  = -0.5873179542866174990000000
				  Csi5  = -0.3678314989981802090000000
				  Csi6  = -0.1252334085114689210000000
				  Csi7  = -Csi6
				  Csi8  = -Csi5
				  Csi9  = -Csi4
				  Csi10 = -Csi3
				  Csi11 = -Csi2
				  Csi12 = -Csi1

				  PSI(1,1)  = 0.5d0 * ( Csi1  + 1.0d0 )
				  PSI(1,2)  = 0.5d0 * ( Csi2  + 1.0d0 )
				  PSI(1,3)  = 0.5d0 * ( Csi3  + 1.0d0 )
				  PSI(1,4)  = 0.5d0 * ( Csi4  + 1.0d0 )
				  PSI(1,5)  = 0.5d0 * ( Csi5  + 1.0d0 )
				  PSI(1,6)  = 0.5d0 * ( Csi6  + 1.0d0 )
				  PSI(1,7)  = 0.5d0 * ( Csi7  + 1.0d0 )
				  PSI(1,8)  = 0.5d0 * ( Csi8  + 1.0d0 )
				  PSI(1,9)  = 0.5d0 * ( Csi9  + 1.0d0 )
				  PSI(1,10) = 0.5d0 * ( Csi10 + 1.0d0 )
				  PSI(1,11) = 0.5d0 * ( Csi11 + 1.0d0 )
				  PSI(1,12) = 0.5d0 * ( Csi12 + 1.0d0 )

				  W(1)  = 0.5d0 * 0.0471753363865117623000000
				  W(2)  = 0.5d0 * 0.1069393259953183480000000
				  W(3)  = 0.5d0 * 0.1600783285433461770000000
				  W(4)  = 0.5d0 * 0.2031674267230659100000000
				  W(5)  = 0.5d0 * 0.2334925365383548150000000
				  W(6)  = 0.5d0 * 0.2491470458134027860000000
				  W(7)  = W(6)
				  W(8)  = W(5)
				  W(9)  = W(4)
				  W(10) = W(3)
				  W(11) = W(2)
				  W(12) = W(1)

              Case (13)
				  Csi1  = -0.9841830547185881650000000
				  Csi2  = -0.9175983992229780190000000
				  Csi3  = -0.8015780907333098530000000
				  Csi4  = -0.6423493394403401900000000
				  Csi5  = -0.4484927510364468760000000
				  Csi6  = -0.2304583159551348040000000
				  Csi7  = 0.0d0
				  Csi8  = -Csi6
				  Csi9  = -Csi5
				  Csi10 = -Csi4
				  Csi11 = -Csi3
				  Csi12 = -Csi2
				  Csi13 = -Csi1

				  PSI(1,1)  = 0.5d0 * ( Csi1  + 1.0d0 )
				  PSI(1,2)  = 0.5d0 * ( Csi2  + 1.0d0 )
				  PSI(1,3)  = 0.5d0 * ( Csi3  + 1.0d0 )
				  PSI(1,4)  = 0.5d0 * ( Csi4  + 1.0d0 )
				  PSI(1,5)  = 0.5d0 * ( Csi5  + 1.0d0 )
				  PSI(1,6)  = 0.5d0 * ( Csi6  + 1.0d0 )
				  PSI(1,7)  = 0.5d0 * ( Csi7  + 1.0d0 )
				  PSI(1,8)  = 0.5d0 * ( Csi8  + 1.0d0 )
				  PSI(1,9)  = 0.5d0 * ( Csi9  + 1.0d0 )
				  PSI(1,10) = 0.5d0 * ( Csi10 + 1.0d0 )
				  PSI(1,11) = 0.5d0 * ( Csi11 + 1.0d0 )
				  PSI(1,12) = 0.5d0 * ( Csi12 + 1.0d0 )
				  PSI(1,13) = 0.5d0 * ( Csi13 + 1.0d0 )

				  W(1)  = 0.5d0 * 0.0404840047653160014000000
				  W(2)  = 0.5d0 * 0.0921214998377283534000000
				  W(3)  = 0.5d0 * 0.1388735102197872450000000
				  W(4)  = 0.5d0 * 0.1781459807619457250000000
				  W(5)  = 0.5d0 * 0.2078160475368885010000000
				  W(6)  = 0.5d0 * 0.2262831802628972380000000
				  W(7)  = 0.5d0 * 0.2325515532308739100000000
				  W(8)  = W(6)
				  W(9)  = W(5)
				  W(10) = W(4)
				  W(11) = W(3)
				  W(12) = W(2)
				  W(13) = W(1)

              Case (20)
				  Csi1  = -0.9931285991850949
				  Csi2  = -0.9639719272779138
				  Csi3  = -0.9122344282513259
				  Csi4  = -0.8391169718222188
				  Csi5  = -0.7463319064601508
				  Csi6  = -0.6360536807265150
				  Csi7  = -0.5108670019508271
				  Csi8  = -0.3737060887154196
				  Csi9  = -0.2277858511416451
				  Csi10 = -0.07652652113349733
				  Csi11 = -Csi10
				  Csi12 = -Csi9
				  Csi13 = -Csi8
				  Csi14 = -Csi7
				  Csi15 = -Csi6
				  Csi16 = -Csi5
				  Csi17 = -Csi4
				  Csi18 = -Csi3
				  Csi19 = -Csi2
				  Csi20 = -Csi1

				  PSI(1,1)  = 0.5d0 * ( Csi1  + 1.0d0 )
				  PSI(1,2)  = 0.5d0 * ( Csi2  + 1.0d0 )
				  PSI(1,3)  = 0.5d0 * ( Csi3  + 1.0d0 )
				  PSI(1,4)  = 0.5d0 * ( Csi4  + 1.0d0 )
				  PSI(1,5)  = 0.5d0 * ( Csi5  + 1.0d0 )
				  PSI(1,6)  = 0.5d0 * ( Csi6  + 1.0d0 )
				  PSI(1,7)  = 0.5d0 * ( Csi7  + 1.0d0 )
				  PSI(1,8)  = 0.5d0 * ( Csi8  + 1.0d0 )
				  PSI(1,9)  = 0.5d0 * ( Csi9  + 1.0d0 )
				  PSI(1,10) = 0.5d0 * ( Csi10 + 1.0d0 )
				  PSI(1,11) = 0.5d0 * ( Csi11 + 1.0d0 )
				  PSI(1,12) = 0.5d0 * ( Csi12 + 1.0d0 )
				  PSI(1,13) = 0.5d0 * ( Csi13 + 1.0d0 )
				  PSI(1,14) = 0.5d0 * ( Csi14 + 1.0d0 )
				  PSI(1,15) = 0.5d0 * ( Csi15 + 1.0d0 )
				  PSI(1,16) = 0.5d0 * ( Csi16 + 1.0d0 )
				  PSI(1,17) = 0.5d0 * ( Csi17 + 1.0d0 )
				  PSI(1,18) = 0.5d0 * ( Csi18 + 1.0d0 )
				  PSI(1,19) = 0.5d0 * ( Csi19 + 1.0d0 )
				  PSI(1,20) = 0.5d0 * ( Csi20 + 1.0d0 )

				  W(1)  = 0.5d0 * 0.01761400713915212
				  W(2)  = 0.5d0 * 0.04060142980038694
				  W(3)  = 0.5d0 * 0.06267204833410906
				  W(4)  = 0.5d0 * 0.08327674157670475
				  W(5)  = 0.5d0 * 0.1019301198172404
				  W(6)  = 0.5d0 * 0.1181945319615184
				  W(7)  = 0.5d0 * 0.1316886384491766
				  W(8)  = 0.5d0 * 0.1420961093183821
				  W(9)  = 0.5d0 * 0.1491729864726037
				  W(10) = 0.5d0 * 0.1527533871307259
				  W(11) = W(10)
				  W(12) = W(9)
				  W(13) = W(8)
				  W(14) = W(7)
				  W(15) = W(6)
				  W(16) = W(5)
				  W(17) = W(4)
				  W(18) = W(3)
				  W(19) = W(2)
				  W(20) = W(1)

              Case (40)
				  Csi1  = -0.9982377097105592
				  Csi2  = -0.9907262386994570
				  Csi3  = -0.9772599499837743
				  Csi4  = -0.9579168192137917
				  Csi5  = -0.9328128082786765
				  Csi6  = -0.9020988069688743
				  Csi7  = -0.8659595032122595
				  Csi8  = -0.8246122308333117
				  Csi9  = -0.7783056514265194
				  Csi10 = -0.7273182551899271
				  Csi11 = -0.6719566846141795
				  Csi12 = -0.6125538896679802
				  Csi13 = -0.5494671250951282
				  Csi14 = -0.4830758016861787
				  Csi15 = -0.4137792043716050
				  Csi16 = -0.3419940908257585
				  Csi17 = -0.2681521850072537
				  Csi18 = -0.1926975807013711
				  Csi19 = -0.1160840706752552
				  Csi20 = -0.03877241750605082
				  Csi21 = -Csi20
				  Csi22 = -Csi19
				  Csi23 = -Csi18
				  Csi24 = -Csi17
				  Csi25 = -Csi16
				  Csi26 = -Csi15
				  Csi27 = -Csi14
				  Csi28 = -Csi13
				  Csi29 = -Csi12
				  Csi30 = -Csi11
				  Csi31 = -Csi10
				  Csi32 = -Csi9
				  Csi33 = -Csi8
				  Csi34 = -Csi7
				  Csi35 = -Csi6
				  Csi36 = -Csi5
				  Csi37 = -Csi4
				  Csi38 = -Csi3
				  Csi39 = -Csi2
				  Csi40 = -Csi1

				  PSI(1,1)  = 0.5d0 * ( Csi1  + 1.0d0 )
				  PSI(1,2)  = 0.5d0 * ( Csi2  + 1.0d0 )
				  PSI(1,3)  = 0.5d0 * ( Csi3  + 1.0d0 )
				  PSI(1,4)  = 0.5d0 * ( Csi4  + 1.0d0 )
				  PSI(1,5)  = 0.5d0 * ( Csi5  + 1.0d0 )
				  PSI(1,6)  = 0.5d0 * ( Csi6  + 1.0d0 )
				  PSI(1,7)  = 0.5d0 * ( Csi7  + 1.0d0 )
				  PSI(1,8)  = 0.5d0 * ( Csi8  + 1.0d0 )
				  PSI(1,9)  = 0.5d0 * ( Csi9  + 1.0d0 )
				  PSI(1,10) = 0.5d0 * ( Csi10 + 1.0d0 )
				  PSI(1,11) = 0.5d0 * ( Csi11 + 1.0d0 )
				  PSI(1,12) = 0.5d0 * ( Csi12 + 1.0d0 )
				  PSI(1,13) = 0.5d0 * ( Csi13 + 1.0d0 )
				  PSI(1,14) = 0.5d0 * ( Csi14 + 1.0d0 )
				  PSI(1,15) = 0.5d0 * ( Csi15 + 1.0d0 )
				  PSI(1,16) = 0.5d0 * ( Csi16 + 1.0d0 )
				  PSI(1,17) = 0.5d0 * ( Csi17 + 1.0d0 )
				  PSI(1,18) = 0.5d0 * ( Csi18 + 1.0d0 )
				  PSI(1,19) = 0.5d0 * ( Csi19 + 1.0d0 )
				  PSI(1,20) = 0.5d0 * ( Csi20 + 1.0d0 )
				  PSI(1,21) = 0.5d0 * ( Csi21 + 1.0d0 )
				  PSI(1,22) = 0.5d0 * ( Csi22 + 1.0d0 )
				  PSI(1,23) = 0.5d0 * ( Csi23 + 1.0d0 )
				  PSI(1,24) = 0.5d0 * ( Csi24 + 1.0d0 )
				  PSI(1,25) = 0.5d0 * ( Csi25 + 1.0d0 )
				  PSI(1,26) = 0.5d0 * ( Csi26 + 1.0d0 )
				  PSI(1,27) = 0.5d0 * ( Csi27 + 1.0d0 )
				  PSI(1,28) = 0.5d0 * ( Csi28 + 1.0d0 )
				  PSI(1,29) = 0.5d0 * ( Csi29 + 1.0d0 )
				  PSI(1,30) = 0.5d0 * ( Csi30 + 1.0d0 )
				  PSI(1,31) = 0.5d0 * ( Csi31 + 1.0d0 )
				  PSI(1,32) = 0.5d0 * ( Csi32 + 1.0d0 )
				  PSI(1,33) = 0.5d0 * ( Csi33 + 1.0d0 )
				  PSI(1,34) = 0.5d0 * ( Csi34 + 1.0d0 )
				  PSI(1,35) = 0.5d0 * ( Csi35 + 1.0d0 )
				  PSI(1,36) = 0.5d0 * ( Csi36 + 1.0d0 )
				  PSI(1,37) = 0.5d0 * ( Csi37 + 1.0d0 )
				  PSI(1,38) = 0.5d0 * ( Csi38 + 1.0d0 )
				  PSI(1,39) = 0.5d0 * ( Csi39 + 1.0d0 )
				  PSI(1,40) = 0.5d0 * ( Csi40 + 1.0d0 )

				  W(1)  = 0.5d0 * 0.004521277098533191
				  W(2)  = 0.5d0 * 0.01049828453115281
				  W(3)  = 0.5d0 * 0.01642105838190789
				  W(4)  = 0.5d0 * 0.02224584919416696
				  W(5)  = 0.5d0 * 0.02793700698002340
				  W(6)  = 0.5d0 * 0.03346019528254785
				  W(7)  = 0.5d0 * 0.03878216797447202
				  W(8)  = 0.5d0 * 0.04387090818567327
				  W(9)  = 0.5d0 * 0.04869580763507223
				  W(10) = 0.5d0 * 0.05322784698393682
				  W(11) = 0.5d0 * 0.05743976909939155
				  W(12) = 0.5d0 * 0.06130624249292894
				  W(13) = 0.5d0 * 0.06480401345660104
				  W(14) = 0.5d0 * 0.06791204581523390
				  W(15) = 0.5d0 * 0.07061164739128678
				  W(16) = 0.5d0 * 0.07288658239580406
				  W(17) = 0.5d0 * 0.07472316905796826
				  W(18) = 0.5d0 * 0.07611036190062624
				  W(19) = 0.5d0 * 0.07703981816424797
				  W(20) = 0.5d0 * 0.07750594797842481
				  W(21) = W(20)
				  W(22) = W(19)
				  W(23) = W(18)
				  W(24) = W(17)
				  W(25) = W(16)
				  W(26) = W(15)
				  W(27) = W(14)
				  W(28) = W(13)
				  W(29) = W(12)
				  W(30) = W(11)
				  W(31) = W(10)
				  W(32) = W(9)
				  W(33) = W(8)
				  W(34) = W(7)
				  W(35) = W(6)
				  W(36) = W(5)
				  W(37) = W(4)
				  W(38) = W(3)
				  W(39) = W(2)
				  W(40) = W(1)



            EndSelect CaseNGP1D

     EndSelect CaseNDimSimplex


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	Case (1)
!     The element is a Hipercube
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        CaseNDimCube: Select case (NDim)
        Case (1)
	        CaseNGPCube: Select case (NGP)
!                integrates exactly a polynomial of order 2*NGP-1
                 Case (1)
                  PSI(1,1) = 0.0D0
!                 Weights  
                  W(1) = 2.0d0

                 Case (2)
                  GaussPoint1 = 1.0d0/Dsqrt(3.0d0)      
                  PSI(1,1) = -GaussPoint1
                  PSI(1,2) =  GaussPoint1
!                 Weights  
                  W(1) = 1.0d0
                  W(2) = 1.0d0

                 Case (3)
                  GaussPoint1 = Dsqrt(0.6d0)      
                  PSI(1,1) = -GaussPoint1
                  PSI(1,2) =  GaussPoint1
                  PSI(1,3) =  0.0d0
!                 Weights  
                  W1 = 5.0d0/9.0d0
                  W(1) = W1
                  W(2) = W1
                  W(3) = 8.0d0/9.0d0

                 Case (4)
                  R = Dsqrt(1.2d0)
                  GaussPoint1 = Dsqrt( (3.0d0+2.0d0*R) / 7.0d0 )      
                  GaussPoint2 = Dsqrt( (3.0d0-2.0d0*R) / 7.0d0 )      
                  PSI(1,1) = -GaussPoint1
                  PSI(1,2) =  GaussPoint1
                  PSI(1,3) = -GaussPoint2
                  PSI(1,4) =  GaussPoint2
!                 Weights  
                  W1 = 1.0d0 / (6.0d0*R)
                  W(1) = (0.5d0-W1)
                  W(2) = (0.5d0-W1)
                  W(3) = (0.5d0+W1)
                  W(4) = (0.5d0+W1)


               EndSelect CaseNGPCube

        EndSelect CaseNDimCube



      EndSelect CaseSimplex

 Return 
end
